//Bibliothek für das auslesen des Laser Distanzsensors
#include "Adafruit_VL53L0X.h"

//Konstanten / Variablen für den Laser Distanzsensor
Adafruit_VL53L0X lox = Adafruit_VL53L0X();

//Um die Debug Ausgaben zu aktivieren
//muss dieser Wert auf "true" gesetzt werden.
#define debugSensor false

//Konstanten / Variablen für den Ultraschall Abstandssensor HC-SR04
const int TrigPin = 2;  //Der PIN welcher auf das Trigger Signal gelegt wird.
const int EchoPin = 3;  //Der PIN welcher auf das Echo Signal gelegt wird.
float cm;

void setup() {
  Serial.begin(9600); //Die Übertragungsgeschwindigkeit setzen.
  pinMode(TrigPin, OUTPUT); //Den Trigger auf das Output Signal des Sainsmart setzen.
  pinMode(EchoPin, INPUT);  //Das Echo auf das Input Signal des Sainsmart setzen.

  //Wenn der Serielle Port bereit ist dann eine Ausgabe auf diesen tätigen
  //und prüfen ob der Sensor korrekt angeschlossen ist (ob dieser Ansprechbar ist)
  if (!lox.begin()) {
    Serial.println("Fehler beim lesen des Sensors!");
    while (1); //eine Endlos Schleife
  }
}

void loop() {
  Serial.println("");
  readLaserDistanceValue();
  readUltrasonicValue();
  delay(2500); //1sek. warten

}

void readLaserDistanceValue() {
  //instanziieren des Sensors zum empfangen von Daten
  VL53L0X_RangingMeasurementData_t measure;
  lox.rangingTest(&measure, debugSensor);

  //lesen des Sensor Status
  //der Sensor kann verschiedene Status annehmen,
  //jedoch interessiert für uns nur der Wert "4"
  int sensorStatus = measure.RangeStatus;
  Serial.print("Laser Distanzsensor VL53LXX-V2:\t\t");
  //Wenn Daten empfangen wurden dann...
  if (sensorStatus != VL53L0X_DEVICEERROR_MSRCNOTARGET) {
    Serial.print(measure.RangeMilliMeter / 10);
    Serial.println("cm");
  } else {
    //Wenn keine Daten empfangen wurden dann wird das wahrscheinlich außerhalb der Reichweite sein.
    Serial.println("-out of Range-");
  }
}

void readUltrasonicValue() {
  digitalWrite(TrigPin, LOW); //Trigger Signal ausschalten
  delayMicroseconds(2);   //2 ms warten
  digitalWrite(TrigPin, HIGH);  //Trigger Signal einschalten
  delayMicroseconds(10);  //10ms warten
  digitalWrite(TrigPin, LOW); //Trigger Signal ausschalten
  cm = pulseIn(EchoPin, HIGH) / 58.0; //Das Empfangene Echo Signal in cm umrechnen
  //Da der Sensor mit einer Messgenauigkeit von 0,3cm arbeitet können wir das
  //Ergbnis auf 2 Nachkommastellen begrenzen
  cm = (int(cm * 100.0)) / 100.0;
  Serial.print("Ultraschall Abstandssensor HC-SR04:\t");
  Serial.print(cm); //Den Wert auf den Seriellen Monitor ausgeben
  Serial.println("cm"); //Der geschriebenen Zeile "cm" anfügen und einen Zeilenumbruch ausführen.
}
